clear all;
rand('seed',0)%set random seed
lambda=5; %arrival rate
mu1=20; 	%service rate
mu2=15; 	%service rate
mu3=10; 	%service rate
alfa=0.6;
endtime=1000; %simulation length
t=0; %current time
tstep=1; %time between consecutive sample events
currcustomers1=0; %current nbr of customers in system 1
currcustomers2=0; %current nbr of customers in system 2
currcustomers3=0; %current nbr of customers in system 3
servtime1=0; %time in server in system 1
servtime2=0; %time in server in system 2
event=[1,4]; %time for next arrival (pos 1),next service completion
             %system 1 (pos 2), next service completion system 2 (pos 3) 
                 %and next sample event (pos 4)
event(1)=exprnd(1/lambda); %next arrival
event(2)=inf; %no customer in system 1
event(3)=inf; %no customer in system 2
event(4)=inf; %no customer in system 2
event(5)=exprnd(tstep); %next sample event
nbr=0; %number of (nbr of customer) measurements made
nbr2=0; %nbr of departed customers from system 1
nbr3=0; %number of (nbr of customer) measurements made
nbr4=0; %nbr of departed customers from system 2
nbr5=0; %number of (nbr of customer) measurements made
nbr6=0; %nbr of departed customers from system 3
nbrarrived1=0; %nbr of cust that have arrived throughout the 
                  %simulations to system 1
nbrarrived2=0; %nbr of cust that have arrived throughout the 
                  %simulations to system 2
nbrarrived3=0; %nbr of cust that have arrived throughout the 
                  %simulations to system 3
while t<endtime %while not simulation finished
   [t,nextevent]=min(event); %find next event
   if nextevent==1 %if next event is a call arrival to system 1
       event(1)=exprnd(1/lambda)+t; %insert time for next call
                                     %arrival event
       if currcustomers1==0 %if no customer in server
	  servtime1=exprnd(1/mu1); %set service time
          event(2)=servtime1+t;
       end
       currcustomers1=currcustomers1+1;
       nbrarrived1=nbrarrived1+1; %one more customer has arrived to 
                                  %system 1 through the simulations
      arrivedtime1(nbrarrived1)=t; %the new customer arrived at time t
   elseif nextevent==2 %call departure from system 1
         currcustomers1=currcustomers1-1;
	 timeinsystem1=t-arrivedtime1(nbrarrived1-currcustomers1);
         nbr2=nbr2+1; %one more customer has departed from 
                         %system 1 through the simulations
         T1(nbr2)=timeinsystem1; %put the total response time in
                                         %vector T1
	 T1s(nbr2)=servtime1; %put the service time in
                                         %vector T1s
         if currcustomers1>0 %if any more customers in system 1
	      servtime1=exprnd(1/mu1); %set time for service
              event(2)=servtime1+t;
         else
            event(2)=inf; %if no customers in system no departure
         end
       if currcustomers2==0 %the departed customer arrives to
                            %system 2, check if no customer in server
	  servtime2=exprnd(1/mu2); %set service time
          event(3)=servtime2+t;
       end
       currcustomers2=currcustomers2+1;
       nbrarrived2=nbrarrived2+1; %one more customer has arrived to 
                                   %system 2 through the simulations
      arrivedtime2(nbrarrived2)=t; %the new customer arrived at time t
   elseif nextevent==3
         currcustomers2=currcustomers2-1;
	 timeinsystem2=t-arrivedtime2(nbrarrived2-currcustomers2);
         nbr4=nbr4+1; %one more customer has departed from 
                         %system 2 through the simulations
         T2(nbr4)=timeinsystem2; %put the total response time in
                                         %vector T2
	 T2s(nbr4)=servtime2; %put the service time in
                                         %vector T2s
	   if currcustomers2>0 %if any more customers in system 2
	      servtime2=exprnd(1/mu2); %set service time
              event(3)=servtime2+t;
           else
            event(3)=inf;
           end
	if rand(1)<alfa %if random number less than alfa go to
                         %system 3
	   if currcustomers3==0 %if no customers
	      servtime3=exprnd(1/mu3); %set service time
              event(4)=servtime3+t;
	   end
           currcustomers3=currcustomers3+1;
           nbrarrived3=nbrarrived3+1; %one more customer has arrived to 
                                   %system 3 through the simulations
           arrivedtime3(nbrarrived3)=t; %the new customer arrived
                                        %at time t
	 end
	 
   elseif nextevent==4 
         currcustomers3=currcustomers3-1;
	 timeinsystem3=t-arrivedtime3(nbrarrived3-currcustomers3);
         nbr6=nbr6+1; %one more customer has departed from 
                         %system 3 through the simulations
         T3(nbr6)=timeinsystem3; %put the total response time in
                                         %vector T3
	 T3s(nbr6)=servtime3; %put the service time in
                                         %vector T3s
         if currcustomers3>0 %if any more customers in system 3
	      servtime3=exprnd(1/mu3); %set service time
              event(4)=servtime3+t;
         else
            event(4)=inf;
         end
       if currcustomers2==0 %if no customers
	  servtime2=exprnd(1/mu2); %set service time
          event(3)=servtime2+t;
       end
       currcustomers2=currcustomers2+1;
       nbrarrived2=nbrarrived2+1; %one more customer has arrived to 
                                   %system 2 through the simulations
      arrivedtime2(nbrarrived2)=t; %the new customer arrived at time t
   else
       nbr=nbr+1; %one more (nbr of customer) measurement made
       N1(nbr)=currcustomers1;
       if currcustomers1>0
         N1q(nbr)=currcustomers1-1;
       else
	 N1q(nbr)=currcustomers1;
       end
       nbr3=nbr3+1; %one more (nbr of customer) measurement made
       N2(nbr3)=currcustomers2;
       if currcustomers2>0
         N2q(nbr3)=currcustomers2-1;
       else
	 N2q(nbr3)=currcustomers2;
       end
       nbr5=nbr5+1; %one more (nbr of customer) measurement made
       N3(nbr5)=currcustomers3;
       if currcustomers3>0
         N3q(nbr5)=currcustomers3-1;
       else
	 N3q(nbr5)=currcustomers3;
       end
       event(5)=event(5)+exprnd(tstep);
   end
 end
