clear all;
rand('seed',0)%set random seed
lambda=5; %arrival rate
mu1=20; 	%service rate
mu2=15; 	%service rate
mu3=10; 	%service rate
alfa=0.6;
endtime=1000; %simulation length
t=0; %current time
tstep=1; %time between consecutive sample events
currcustomers1=0; %current nbr of customers in system 1
currcustomers21=0; %current nbr of customers that have returned to system 2
currcustomers22=0; %current nbr of customers in system 2 from
                   %system 1
currcustomers3=0; %current nbr of customers in system 3
servtime1=0; %time in server in system 1
servtime2=0; %time in server in system 2
servtime3=0; %time in server in system 3
event=[1,4]; %time for next arrival (pos 1),next service completion
             %system 1 (pos 2), next service completion system 2 (pos 3) 
                 %and next sample event (pos 4)
event(1)=exprnd(1/lambda); %next arrival
event(2)=inf; %no customer in system 1
event(3)=inf; %no customer in system 2
event(4)=inf; %no customer in system 3
event(5)=exprnd(tstep); %next sample event
inserver2=0; %from which queue the customer in server 2 is
nbr=0; %number of (nbr of customer) measurements made
nbr2=0; %nbr of departed customers from system 1
nbr3=0; %number of (nbr of customer) measurements made
nbr4=0; %nbr of departed customers from system 2
nbr41=0; %nbr of departed customers from system 2 from queue 1
nbr42=0; %nbr of departed customers from system 2 from queue 2
nbr5=0; %number of (nbr of customer) measurements made
nbr6=0; %nbr of departed customers from system 3
nbrarrived1=0; %nbr of cust that have arrived throughout the 
                  %simulations to system 1
nbrarrived21=0; %nbr of cust that have arrived throughout the 
                  %simulations	to system 2 again
nbrarrived22=0; %nbr of cust that have arrived throughout the 
                  %simulations	to system 2 from system 1
nbrarrived3=0; %nbr of cust that have arrived throughout the 
                  %simulations	to system 3
while t<endtime
   [t,nextevent]=min(event);
   if nextevent==1
       event(1)=exprnd(1/lambda)+t;
       if currcustomers1==0
	  servtime1=exprnd(1/mu1);
          event(2)=servtime1+t;
       end
       currcustomers1=currcustomers1+1;
       nbrarrived1=nbrarrived1+1; %one more customer has arrived to 
                                  %system 1 through the simulations
      arrivedtime1(nbrarrived1)=t; %the new customer arrived at time t
   elseif nextevent==2
         currcustomers1=currcustomers1-1;
	 timeinsystem1=t-arrivedtime1(nbrarrived1-currcustomers1);
         nbr2=nbr2+1; %one more customer has departed from 
                         %system 1 through the simulations
         T1(nbr2)=timeinsystem1;
	 T1s(nbr2)=servtime1;
         if currcustomers1>0
	      servtime1=exprnd(1/mu1);
              event(2)=servtime1+t;
         else
            event(2)=inf;
         end
       if currcustomers21==0
	 if currcustomers22==0
          inserver2=2; %the customer in server 2 is from queue 2
	  servtime2=exprnd(1/mu2);
          event(3)=servtime2+t;
	 end
       end
       currcustomers22=currcustomers22+1;
       nbrarrived22=nbrarrived22+1; %one more customer has arrived to 
                                   %system 2 to queue 2 from system 1
      arrivedtime22(nbrarrived22)=t; %the new customer arrived at time t
   elseif nextevent==3
     if inserver2==1 %if the customer in server 2 is from queue 2 then
         currcustomers21=currcustomers21-1;
	 timeinsystem2=t-arrivedtime21(nbrarrived21-currcustomers21);
         nbr4=nbr4+1;
         nbr41=nbr41+1; %one more customer has departed from 
                         %system 2 through the simulations
         T2(nbr4)=timeinsystem2; %the time the customer spent in system 2
         T21(nbr41)=timeinsystem2; %the time the customer spent in system 2
	                           %returning to system 2
         T2s(nbr4)=servtime2;
	 T21s(nbr41)=servtime2;
     else
         currcustomers22=currcustomers22-1;
	 timeinsystem2=t-arrivedtime22(nbrarrived22-currcustomers22);
         nbr4=nbr4+1;
         nbr42=nbr42+1; %one more customer has departed from 
                         %system 2 through the simulations
         T2(nbr4)=timeinsystem2; %the time the customer spent in system 2
         T22(nbr42)=timeinsystem2; %the time the customer spent in system 2
	                           %coming from system 1
         T2s(nbr4)=servtime2;
	 T22s(nbr42)=servtime2;
     end
         
	 if currcustomers21>0
            inserver2=1; %the customer in server 2 is from queue 1
	    servtime2=exprnd(1/mu2);
            event(3)=servtime2+t;
	 elseif currcustomers22>0
	    inserver2=2; %the customer in server 2 is from queue 2
	    servtime2=exprnd(1/mu2);
            event(3)=servtime2+t;
         else
            event(3)=inf;
         end
	 if rand(1)<alfa
	   if currcustomers3==0
	      servtime3=exprnd(1/mu3);
              event(4)=servtime3+t;
	   end
           currcustomers3=currcustomers3+1;
           nbrarrived3=nbrarrived3+1; %one more customer has arrived to 
                                   %system 3 through the simulations
           arrivedtime3(nbrarrived3)=t; %the new customer arrived
                                        %at time t
	 end
   elseif nextevent==4
         currcustomers3=currcustomers3-1;
	 timeinsystem3=t-arrivedtime3(nbrarrived3-currcustomers3);
         nbr6=nbr6+1; %one more customer has departed from 
                         %system 3 through the simulations
         T3(nbr6)=timeinsystem3;
	 T3s(nbr6)=servtime3;
         if currcustomers3>0
	      servtime3=exprnd(1/mu3);
              event(4)=servtime3+t;
         else
            event(4)=inf;
         end
       if currcustomers21==0
	 if currcustomers22==0
          inserver2=1; %the customer in server 2 is from queue 1
	  servtime2=exprnd(1/mu2);
          event(3)=servtime2+t;
	 end
       end
       currcustomers21=currcustomers21+1;
       nbrarrived21=nbrarrived21+1; %one more customer has arrived to 
                                   %system 2 through the simulations
      arrivedtime21(nbrarrived21)=t; %the new customer arrived at time t
   else
       nbr=nbr+1; %one more (nbr of customer) measurement made
       N1(nbr)=currcustomers1;
       if currcustomers1>0
         N1q(nbr)=currcustomers1-1;
       else
	 N1q(nbr)=currcustomers1;
       end
       nbr3=nbr3+1; %one more (nbr of customer) measurement made
       N2(nbr3)=currcustomers21+currcustomers22; %add the customers in both of 
                                                 %the queues
       if currcustomers21+currcustomers22>0
         N2q(nbr3)=currcustomers21+currcustomers22-1;
       else
	 N2q(nbr3)=currcustomers21+currcustomers22;
       end
       nbr5=nbr5+1; %one more (nbr of customer) measurement made
       N3(nbr5)=currcustomers3;
       if currcustomers3>0
         N3q(nbr5)=currcustomers3-1;
       else
	 N3q(nbr5)=currcustomers3;
       end
       event(5)=event(5)+exprnd(tstep);
   end
 end
